=== debian/changelog ===
gitano (0.1-2) unstable; urgency=medium

  * Add gnupg to Build-Depends and Depends. (Closes: #841628)

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 22 Oct 2016 10:48:55 +0900

gitano (0.1-1) unstable; urgency=medium

  * Initial packaging of Gitano as a separate project.
  * Closes: #700408

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Tue, 18 Oct 2016 23:08:40 +0900
