=== debian/rules ===
#!/usr/bin/make -f

# Set up the variables the Gitano makefile needs
PREFIX:=/usr
export PREFIX
LUA_VER:=5.1
export LUA_VER

# And Debhelper the world

%:
	dh $@
