## gitano 0.2

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 LUA_VER := 5.1
 LUA := /usr/bin/lua$(LUA_VER)
+LUAC := /usr/bin/luac$(LUA_VER)
 PREFIX ?= /usr/local
 INST_ROOT := $(PREFIX)
 SYSCONF_DIR ?= /etc
@@ -47,7 +48,8 @@
 	gitano.actions gitano.config gitano.lace gitano.log		\
 	gitano.markdown gitano.repository gitano.supple 		\
 	gitano.command gitano.admincommand gitano.usercommand		\
-	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins
+	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins\
+	gitano.i18n
 
 SKEL_FILES := gitano-admin/rules/selfchecks.lace			\
 	      gitano-admin/rules/aschecks.lace 				\
@@ -112,6 +114,7 @@
 endef
 
 local: $(LOCAL_BINS)
+	$(LUAC) -p $(LOCAL_BINS)
 
 clean:
 	@echo "CLEAN: local binaries"
@@ -168,7 +171,7 @@
 		install -m 644 $$LANGFILE $(DESTDIR)$(INST_ROOT)/lib/gitano/plugins; \
 	done
 
-YARN_ARGS :=
+YARN_ARGS ?=
 ifneq ($(LUA_PATH),)
 YARN_ARGS += --env LUA_PATH="$(LUA_PATH)"
 endif
@@ -179,10 +182,40 @@
 YARN_ARGS += --run "$(SCENARIO)"
 endif
 
+ifneq ($(YARN_SNAPSHOT),)
+YARN_ARGS += --snapshot
+endif
+
+TEST_PROTO ?= ssh
+
+ifeq ($(filter $(TEST_PROTO),ssh http),)
+$(error TEST_PROTO should be ssh or http)
+endif
+
+basictest: local $(TEST_BINS)
+	@echo "Running basic yarns in '$(TEST_PROTO)' mode"
+	@echo "Set TEST_PROTO if you want to change that"
+	@$(YARN)							 \
+		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
+		--env GTT_PROTO=$(TEST_PROTO) 				 \
+		$(YARN_ARGS)                                             \
+	        testing/library.yarn testing/01*.yarn
+
 test: local $(TEST_BINS)
-	@$(YARN) --env GTT="$$(pwd)/testing/gitano-test-tool"			\
-		 $(YARN_ARGS)                                                   \
+	@echo "Running full yarns in 'ssh' mode"
+	@$(YARN)							 \
+		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
+		--env GTT_PROTO=ssh 					 \
+		$(YARN_ARGS)                                             \
+	        testing/library.yarn $(TESTS)
+	@echo "Running full yarns in 'http' mode"
+	@$(YARN)							 \
+		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
+		--env GTT_PROTO=ssh 					 \
+		$(YARN_ARGS)                                             \
 	        testing/library.yarn $(TESTS)
 
 testing/%: testing/%.in $(GEN_BIN)
 	$(call GEN_LOCAL_BIN,$<,$@)
+
+check: test
