=== debian/changelog ===
gitano (0.2-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 03 Dec 2016 18:03:39 +0000

gitano (0.1-3) unstable; urgency=medium

  * Add curl to Depends since it's needed for HTTP(s) transactions from
    hook functions.

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 05 Nov 2016 11:28:52 +0000
