=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}, git, lua-lace, lua-supple,
   lua-clod, lua-gall, lua-scrypt, lua-luxio0, lua5.1, lua-rex-pcre, rsync,
-  lua-tongue, gnupg
+  lua-tongue, gnupg, curl
 Description: Git service manager
  Gitano is a Git service manager along similar lines to Gitosos or Gitolite.
  Gitano is focussed on being configured entirely via Git and can be commanded
