## gitano 0.8.1

=== doc/admin/Makefile ===
sources = $(wildcard *.mdwn)

all: gitano-admin-doc.pdf gitano-admin-doc.html

gitano-admin-doc.pdf: $(sources) Makefile
	pandoc --toc -o gitano-admin-doc.pdf $(sources)

gitano-admin-doc.html: $(sources) Makefile
	pandoc --toc --standalone -o gitano-admin-doc.html $(sources)
