=== debian/changelog ===
gitano (0.8.1-1) unstable; urgency=medium

  * New upstream release
  * Build-depend on procps so that the HTTP test suite can tear down
    cleanly

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Mon, 02 Jan 2017 19:06:29 +0000

gitano (0.8-1) unstable; urgency=medium

  * New upstream release
  * Clean up copyright statement because markdown.lua is no longer
    included in upstream
  * Add apache2-utils and lighttpd to the build-depends since the HTTP
    test suite depends on them.
  * Suggest git-annex so that the git-annex-shell plugin will work
  * Recommend rsync and apache2-utils so that the rsync plugin and the
    passwd command will work.

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Mon, 02 Jan 2017 18:26:42 +0000
