=== debian/control ===
Source: gitano
Section: interpreters
Priority: optional
Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
Build-Depends: debhelper (>= 9.20120909~), lua-luxio, cmdtest (>= 0.12),
  lua-lace, lua-supple (>=1.0.7), lua-clod, lua-gall, lua-scrypt, git, lua5.1,
  lua-rex-pcre, lua-tongue, rsync, gnupg, apache2-utils, lighttpd, procps
Standards-Version: 3.9.8
Homepage: https://www.gitano.org.uk/supple/

Package: gitano
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, git, lua-lace, lua-supple,
  lua-clod, lua-gall, lua-scrypt, lua-luxio0, lua5.1, lua-rex-pcre,
  lua-tongue, gnupg, curl
Recommends: rsync, apache2-utils
Suggests: git-annex
Description: Git service manager
 Gitano is a Git service manager along similar lines to Gitosos or Gitolite.
 Gitano is focussed on being configured entirely via Git and can be commanded
 over SSH.  Gitano has support for running hooks with limited functionality in
 a sandbox so as to allow for untrusted parties writing hook code.  Gitano also
 has a fully-fledged ACL system which allows individual projects to create
 their own rulesets, along with supporting complex delegable permissions.
