## gitano 1.0

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
          02-commands-fsck 02-commands-gc 02-commands-graveyard			\
          02-commands-git-upload-archive 02-commands-group 02-commands-help	\
          02-commands-keyring \
-         02-commands-ls 02-commands-readme 02-commands-rename 02-commands-rsync	\
+         02-commands-ls 02-commands-rename 02-commands-rsync	\
          02-commands-sshkey 02-commands-user 02-commands-whoami 03-cgit-support	\
          03-shallow-push
 
@@ -46,7 +46,7 @@
 									\
 	gitano.util							\
 	gitano.actions gitano.config gitano.lace gitano.log		\
-	gitano.markdown gitano.repository gitano.supple 		\
+	gitano.repository gitano.supple 		\
 	gitano.command gitano.admincommand gitano.usercommand		\
 	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins\
 	gitano.i18n
@@ -68,7 +68,7 @@
 MAN1S := gitano-setup.1
 
 
-PLUGINS := rsync.lua archive.lua
+PLUGINS := rsync.lua archive.lua git-annex.lua
 
 MOD_DIRS := gitano
 MOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(MODS)))
@@ -171,19 +171,19 @@
 		install -m 644 $$LANGFILE $(DESTDIR)$(INST_ROOT)/lib/gitano/plugins; \
 	done
 
-YARN_ARGS ?=
+override YARN_ARGS := $(YARN_ARGS)
 ifneq ($(LUA_PATH),)
-YARN_ARGS += --env LUA_PATH="$(LUA_PATH)"
+override YARN_ARGS += --env LUA_PATH="$(LUA_PATH)"
 endif
 ifneq ($(LUA_CPATH),)
-YARN_ARGS += --env LUA_CPATH="$(LUA_CPATH)"
+override YARN_ARGS += --env LUA_CPATH="$(LUA_CPATH)"
 endif
 ifneq ($(SCENARIO),)
-YARN_ARGS += --run "$(SCENARIO)"
+override YARN_ARGS += --run "$(SCENARIO)"
 endif
 
 ifneq ($(YARN_SNAPSHOT),)
-YARN_ARGS += --snapshot
+override YARN_ARGS += --snapshot
 endif
 
 TEST_PROTO ?= ssh
@@ -192,28 +192,51 @@
 $(error TEST_PROTO should be ssh or http)
 endif
 
-basictest: local $(TEST_BINS)
+ifeq ($(HTTP_FIRST_TEST_PORT),)
+HTTP_FIRST_TEST_PORT = 8080
+endif
+
+plugin-check:
+	$(LUAC) -p $(patsubst %,plugins/%,$(PLUGINS))
+	for PLUGIN in $(patsubst %,plugins/%,$(PLUGINS)); do \
+		env LUA_PATH="$(shell pwd)/lib/?.lua;;" $(LUA) $$PLUGIN; \
+	done
+
+basictest: local plugin-check $(TEST_BINS)
 	@echo "Running basic yarns in '$(TEST_PROTO)' mode"
 	@echo "Set TEST_PROTO if you want to change that"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
 		--env GTT_PROTO=$(TEST_PROTO) 				 \
+		--env HTTP_FIRST_TEST_PORT=$(HTTP_FIRST_TEST_PORT)       \
 		$(YARN_ARGS)                                             \
 	        testing/library.yarn testing/01*.yarn
 
-test: local $(TEST_BINS)
+test: local plugin-check sshtests httptests
+
+sshtests: $(TEST_BINS)
 	@echo "Running full yarns in 'ssh' mode"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
 		--env GTT_PROTO=ssh 					 \
+		--env HTTP_FIRST_TEST_PORT=$(HTTP_FIRST_TEST_PORT)       \
 		$(YARN_ARGS)                                             \
 	        testing/library.yarn $(TESTS)
+
+ifeq ($(SKIP_HTTP_TESTS),)
+httptests: $(TEST_BINS)
 	@echo "Running full yarns in 'http' mode"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
-		--env GTT_PROTO=ssh 					 \
+		--env GTT_PROTO=http 					 \
+		--env HTTP_FIRST_TEST_PORT=$(HTTP_FIRST_TEST_PORT)       \
 		$(YARN_ARGS)                                             \
 	        testing/library.yarn $(TESTS)
+else
+httptests:
+	@echo "WARNING: Running of yarns in 'http' mode disabled."
+	@echo "WARNING: Cannot guarantee Gitano will work in HTTP mode."
+endif
 
 testing/%: testing/%.in $(GEN_BIN)
 	$(call GEN_LOCAL_BIN,$<,$@)
