=== doc/admin/Makefile ===
sources = $(wildcard *.mdwn)

all: gitano-admin-doc.pdf gitano-admin-doc.html

gitano-admin-doc.pdf: $(sources) Makefile titling.tex header.tex
	pandoc --standalone --toc --chapters -V documentclass:report -V geometry:margin=1in -V graphics:true -V papersize:a4paper -H titling.tex -H header.tex -o gitano-admin-doc.pdf $(sources)

gitano-admin-doc.html: $(sources) Makefile manual.css image.html
	pandoc --toc --standalone --css manual.css -B image.html -o gitano-admin-doc.html $(sources)

clean:
	$(RM) gitano-admin-doc.pdf gitano-admin-doc.html
