=== debian/changelog ===
gitano (1.0-2) unstable; urgency=medium

  * Fix missing copyright field

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Wed, 18 Jan 2017 23:21:46 +0000

gitano (1.0-1) unstable; urgency=medium

  * New upstream release
  * Includes administrator manual
      * Significant updates to debian/copyright
      * Addition of pandoc et al. to the build dependencies

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sun, 15 Jan 2017 16:19:33 +0000
