=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
 Build-Depends: debhelper (>= 9.20120909~), lua-luxio, cmdtest (>= 0.12),
   lua-lace, lua-supple (>=1.0.7), lua-clod, lua-gall, lua-scrypt, git, lua5.1,
-  lua-rex-pcre, lua-tongue, rsync, gnupg, apache2-utils, lighttpd, procps
+  lua-rex-pcre, lua-tongue, rsync, gnupg, apache2-utils, lighttpd, procps,
+  pandoc, texlive-latex-recommended, texlive-xetex, texlive-luatex, lmodern,
+  texlive-fonts-recommended
 Standards-Version: 3.9.8
-Homepage: https://www.gitano.org.uk/supple/
+Homepage: https://www.gitano.org.uk/
 
 Package: gitano
 Architecture: all
