## gitano 1.1

=== Makefile ===
--- 
+++ 
@@ -32,14 +32,15 @@
 
 TEST_BIN_NAMES := gitano-test-tool
 
-TESTS := 01-basics 02-commands-as 02-commands-config 02-commands-copy		\
-         02-commands-count-objects 02-commands-create 02-commands-destroy	\
-         02-commands-fsck 02-commands-gc 02-commands-graveyard			\
-         02-commands-git-upload-archive 02-commands-group 02-commands-help	\
-         02-commands-keyring \
-         02-commands-ls 02-commands-rename 02-commands-rsync	\
-         02-commands-sshkey 02-commands-user 02-commands-whoami 03-cgit-support	\
-         03-shallow-push
+TESTS := 01-basics 01-hooks 02-commands-as 02-commands-config 02-commands-copy  \
+         02-commands-count-objects 02-commands-create 02-commands-destroy       \
+         02-commands-fsck 02-commands-gc 02-commands-graveyard                  \
+         02-commands-git-upload-archive 02-commands-group 02-commands-help      \
+         02-commands-keyring                                                    \
+         02-commands-ls 02-commands-rename 02-commands-rsync                    \
+         02-commands-sshkey 02-commands-user 02-commands-whoami 03-cgit-support \
+         03-shallow-push 03-treedelta-rules 03-force-pushing                    \
+         03-dangling-HEAD 03-config-user-whitelist
 
 
 MODS := gitano 								\
@@ -49,7 +50,7 @@
 	gitano.repository gitano.supple 		\
 	gitano.command gitano.admincommand gitano.usercommand		\
 	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins\
-	gitano.i18n
+	gitano.i18n gitano.hooks gitano.patterns
 
 SKEL_FILES := gitano-admin/rules/selfchecks.lace			\
 	      gitano-admin/rules/aschecks.lace 				\
@@ -61,7 +62,8 @@
 	      gitano-admin/rules/defines.lace				\
 	      gitano-admin/rules/project.lace				\
 	      gitano-admin/rules/adminchecks.lace			\
-	      gitano-admin/rules/createrepo.lace
+	      gitano-admin/rules/createrepo.lace			\
+	      gitano-admin/rules/simpleprojectauth.lace
 
 LANG_FILES := json.lua en.lua
 
@@ -69,6 +71,18 @@
 
 
 PLUGINS := rsync.lua archive.lua git-annex.lua
+
+TEST_PLUGINS := testing-hooks.lua demo.lua
+
+UNSUPPORTED_PLUGINS := git-multimail.lua
+
+COVERAGE := no
+
+ifeq ($(COVERAGE),yes)
+
+MODS := $(MODS) gitano.coverage
+
+endif
 
 MOD_DIRS := gitano
 MOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(MODS)))
@@ -86,20 +100,59 @@
 
 GEN_BIN := utils/install-lua-bin
 RUN_GEN_BIN := $(LUA) $(GEN_BIN) $(LUA)
+
+ifeq ($(COVERAGE),yes)
 define GEN_LOCAL_BIN
 
+$(RUN_GEN_BIN) $(shell pwd) $(shell pwd)/bin $(shell pwd)/lib $(shell pwd)/plugins $1 $2 $(shell pwd)/extras/luacov/src $(shell pwd)/.coverage/
+chmod 755 $2
+
+endef
+ifeq ($(COVER_GTT),yes)
+define GEN_LOCAL_TESTING_BIN
+
+$(RUN_GEN_BIN) $(shell pwd)/testing/inst/share/gitano $(shell pwd)/testing/inst/lib/gitano/bin $(shell pwd)/testing/inst/share/lua/5.1 $(shell pwd)/testing/inst/lib/gitano/plugins $1 $2 $(shell pwd)/extras/luacov/src $(shell pwd)/.coverage/
+chmod 755 $2
+
+endef
+else
+define GEN_LOCAL_TESTING_BIN
+
+$(RUN_GEN_BIN) $(shell pwd)/testing/inst/share/gitano $(shell pwd)/testing/inst/lib/gitano/bin $(shell pwd)/testing/inst/share/lua/5.1 $(shell pwd)/testing/inst/lib/gitano/plugins $1 $2
+chmod 755 $2
+
+endef
+endif
+else
+define GEN_LOCAL_BIN
+
 $(RUN_GEN_BIN) $(shell pwd) $(shell pwd)/bin $(shell pwd)/lib $(shell pwd)/plugins $1 $2
 chmod 755 $2
 
 endef
-
+define GEN_LOCAL_TESTING_BIN
+
+$(RUN_GEN_BIN) $(shell pwd)/testing/inst/share/gitano $(shell pwd)/testing/inst/lib/gitano/bin $(shell pwd)/testing/inst/share/lua/5.1 $(shell pwd)/testing/inst/lib/gitano/plugins $1 $2
+chmod 755 $2
+
+endef
+endif
+
+ifeq ($(COVERAGE),yes)
 define GEN_INSTALL_BIN
 
+$(RUN_GEN_BIN) $(SHARE_PATH) $(LIB_BIN_PATH) $(LUA_MOD_PATH) $(PLUGIN_PATH) $1 $2 $(shell pwd)/extras/luacov/src $(shell pwd)/.coverage/
+chmod 755 $2
+
+endef
+else
+define GEN_INSTALL_BIN
+
 $(RUN_GEN_BIN) $(SHARE_PATH) $(LIB_BIN_PATH) $(LUA_MOD_PATH) $(PLUGIN_PATH) $1 $2
 chmod 755 $2
 
 endef
-
+endif
 define GEN_INSTALL_MAN
 
 cp $1 $2
@@ -113,23 +166,53 @@
 
 endef
 
-local: $(LOCAL_BINS)
-	$(LUAC) -p $(LOCAL_BINS)
-
-clean:
-	@echo "CLEAN: local binaries"
-	@$(RM) $(LOCAL_BINS)
+define GEN_LOCAL_MOD
+
+$(RUN_GEN_BIN) $(shell pwd) $(shell pwd)/bin $(shell pwd)/lib $(shell pwd)/plugins $1 $2
+
+endef
+
+LOCAL_MODS := lib/gitano/coverage.lua
+
+local: $(LOCAL_BINS) $(LOCAL_MODS)
+	@$(LUAC) -p $(LOCAL_BINS) $(LOCAL_MODS)
+	@mkdir -p .coverage
+ifeq ($(COVERAGE),yes)
+	@echo NOTE: Coverage gathering enabled
+	@if ! test -r extras/luacov/src/luacov; then \
+		echo "CANNOT COVERAGE TEST, LUACOV MODULE NOT AVAILABLE"; \
+		echo "Please run: git submodule init && git submodule update"; \
+	fi
+else
+	@echo NOTE: Coverage gathering is not enabled
+endif
+
+clean: cleanbins
+	@echo "CLEAN: coverage stats and reports"
+	@$(RM) -r .coverage luacov.stats.out luacov.report.out
+
+cleanbins:
+	@echo "CLEAN: local binaries and modules"
+	@$(RM) $(LOCAL_BINS) $(LOCAL_MODS)
 	@echo "CLEAN: test binaries"
 	@$(RM) $(TEST_BINS)
+	@echo "CLEAN: test install"
+	@$(RM) -r testing/inst
 
 distclean: clean
 	@find . -name "*~" -delete
 
-bin/%: bin/%.in $(GEN_BIN)
-	$(call GEN_LOCAL_BIN,$<,$@)
-
-testing/%: testing/%.in $(GEN_BIN)
-	$(call GEN_LOCAL_BIN,$<,$@)
+bin/%: bin/%.in $(GEN_BIN) FORCE
+	@$(call GEN_LOCAL_BIN,$<,$@)
+
+testing/%: testing/%.in $(GEN_BIN) FORCE
+	@$(call GEN_LOCAL_TESTING_BIN,$<,$@)
+
+lib/gitano/%.lua: lib/gitano/%.lua.in $(GEN_BIN) FORCE
+	@$(call GEN_LOCAL_MOD,$<,$@)
+
+FORCE:
+.PHONY: FORCE
 
 install: install-bins install-lib-bins install-mods install-skel install-man install-plugins install-lang
 
@@ -196,13 +279,22 @@
 HTTP_FIRST_TEST_PORT = 8080
 endif
 
+test-install:
+	@$(RM) -r testing/inst
+	@$(MAKE) PREFIX="$(shell pwd)/testing/inst" \
+              SYSCONF_DIR="$(shell pwd)/testing/inst/etc" \
+              install >/dev/null
+	@for P in $(TEST_PLUGINS); do \
+		cp plugins/$$P "$(shell pwd)/testing/inst/etc/gitano/plugins/"; \
+	done
+
 plugin-check:
-	$(LUAC) -p $(patsubst %,plugins/%,$(PLUGINS))
-	for PLUGIN in $(patsubst %,plugins/%,$(PLUGINS)); do \
+	$(LUAC) -p $(patsubst %,plugins/%,$(PLUGINS) $(TEST_PLUGINS) $(UNSUPPORTED_PLUGINS))
+	for PLUGIN in $(patsubst %,plugins/%,$(PLUGINS) $(TEST_PLUGINS)); do \
 		env LUA_PATH="$(shell pwd)/lib/?.lua;;" $(LUA) $$PLUGIN; \
 	done
 
-basictest: local plugin-check $(TEST_BINS)
+basictest: local plugin-check $(TEST_BINS) test-install
 	@echo "Running basic yarns in '$(TEST_PROTO)' mode"
 	@echo "Set TEST_PROTO if you want to change that"
 	@$(YARN)							 \
@@ -214,7 +306,7 @@
 
 test: local plugin-check sshtests httptests
 
-sshtests: $(TEST_BINS)
+sshtests: $(TEST_BINS) test-install
 	@echo "Running full yarns in 'ssh' mode"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
@@ -224,7 +316,7 @@
 	        testing/library.yarn $(TESTS)
 
 ifeq ($(SKIP_HTTP_TESTS),)
-httptests: $(TEST_BINS)
+httptests: $(TEST_BINS) test-install
 	@echo "Running full yarns in 'http' mode"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
@@ -238,7 +330,12 @@
 	@echo "WARNING: Cannot guarantee Gitano will work in HTTP mode."
 endif
 
-testing/%: testing/%.in $(GEN_BIN)
-	$(call GEN_LOCAL_BIN,$<,$@)
-
 check: test
+
+coverage-report:
+	@echo "COVERAGE: Merge stats..."
+	@env LUA_PATH="$(shell pwd)/extras/luacov/src/?.lua;;" $(LUA) utils/merge-luacov-stats .coverage/luacov.stats-*.out
+	@echo "COVERAGE: Generate report..."
+	@env LUA_PATH="$(shell pwd)/extras/luacov/src/?.lua;;" $(LUA) extras/luacov/src/bin/luacov
+	@echo "COVERAGE: Summary:"
+	@sed '0,/^Summary/d' < luacov.report.out | tail -n +2 | sed -e's/^/COVERAGE: /'
