=== debian/changelog ===
gitano (1.1-1) unstable; urgency=medium

  * New upstream release
  * Also copy the multimail plugin and its README to usr/share/doc

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Thu, 03 Aug 2017 11:12:31 -0400
