=== debian/rules ===
--- 
+++ 
@@ -10,3 +10,7 @@
 
 %:
 	dh $@
+
+override_dh_auto_build:
+	make
+	make -C doc/admin
