## gitano 1.1.1

=== debian/changelog ===
gitano (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * Override PANDOC_ARGS_CHAPTERS for new pandoc

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Fri, 01 Jun 2018 11:04:49 +0100
