=== debian/watch ===
version=3
https://git.gitano.org.uk/gitano.git /gitano\.git/snapshot/gitano-(.+)\.tar.bz2
