## gitano 1.2

=== doc/admin/Makefile ===
sources = $(wildcard *.mdwn)

all: gitano-admin-doc.pdf gitano-admin-doc.html

PANDOC_ARGS_SHAPE := --standalone --toc
PANDOC_ARGS_CHAPTERS := --chapters
PANDOC_PDF_ARGS_SETTINGS := -V documentclass:report -V geometry:margin=1in -V graphics:true -V papersize:a4paper
PANDOC_PDF_ARGS := $(PANDOC_ARGS_SHAPE) $(PANDOC_ARGS_CHAPTERS) $(PANDOC_PDF_ARGS_SETTINGS) -H titling.tex -H header.tex

PANDOC_HTML_ARGS_SETTINGS := --css manual.css -B image.html
PANDOC_HTML_ARGS := $(PANDOC_ARGS_SHAPE) $(PANDOC_HTML_ARGS_SETTINGS)

gitano-admin-doc.pdf: $(sources) Makefile titling.tex header.tex
	pandoc $(PANDOC_PDF_ARGS) -o gitano-admin-doc.pdf $(sources)

gitano-admin-doc.html: $(sources) Makefile manual.css image.html
	pandoc $(PANDOC_HTML_ARGS) -o gitano-admin-doc.html $(sources)

clean:
	$(RM) gitano-admin-doc.pdf gitano-admin-doc.html
