=== debian/changelog ===
gitano (1.2-1) unstable; urgency=medium

  * New upstream release
    Closes: #876078
  * Apply patch from Jonathan Dowland to correct debian/copyright
    Closes: #907989

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 19 Jan 2019 13:55:33 +0000
