=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
   lua-lace, lua-supple (>=1.0.7), lua-clod, lua-gall, lua-scrypt, git, lua5.1,
   lua-rex-pcre, lua-tongue, rsync, gnupg, apache2-utils, lighttpd, procps,
   pandoc, texlive-latex-recommended, texlive-xetex, texlive-luatex, lmodern,
-  texlive-fonts-recommended
+  texlive-fonts-recommended, wget
 Standards-Version: 3.9.8
 Homepage: https://www.gitano.org.uk/
