=== debian/rules ===
--- 
+++ 
@@ -13,4 +13,4 @@
 
 override_dh_auto_build:
 	make
-	make -C doc/admin
+	make -C doc/admin PANDOC_ARGS_CHAPTERS=--top-level-division=chapter
